#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
ll fja(ll a[],ll n,ll i,ll j)
{
    ll rez=0;
    for(ll k=i;k<=j;k++) rez+=a[k];
    return rez;
}
ll k0(ll a[],ll n,ll i,ll j)
{
    ll rez=0;
    for(ll k=i;k<j;k++) rez+=a[k];
    return rez;
}
ll resenje(ll a[],ll n,ll k,ll pom)
{
    if(k==0) return 0;
    for(ll i=0;i<n;i++)
        for(ll j=i;j<n;j++) pom+=fja(a,n,i,j);
    return pom+resenje(a,n,k-1,0);
}
int main()
{
    ios::sync_with_stdio(false);
    ll n,k;
    cin >> n >> k;
    ll a[n];
    for(int i=0;i<n;i++)
        cin >> a[i];
    ll pom = pow(10,9)+7;
    if(k==0)   cout << k0(a,n,0,n) % pom << '\n';
    else
    cout <<  resenje(a,n,k,0) % pom << '\n';
    return 0;
}